import unit4.collectionsLib.Map;
import unit4.collectionsLib.Node;
import unit4.ioLib.IO;
/**
 *   :   
 * @author  , '  
 * @version 3/1/2007
 */
public class CarWash
{
	//          
	private Map<CarWashData> carMap ;
	public static final int BOUNDARY_OF_WASHES = 5;
	public static final int PRICE_FOR_FIRSTS_EXTERNAL_WASHES = 20;
	public static final int PRICE_FOR_FIRSTS_COMBINED_WASHES = 30;
	public static final int PRICE_FOR_LASTS_EXTERNAL_WASHES = 18;
	public static final int PRICE_FOR_LASTS_COMBINED_WASHES = 24;
	 
	public CarWash()
	{
		this.carMap = new Map<CarWashData>();
	}
	 
	public boolean carExists(int carNum)
	{
		String carString = new String(new Integer(carNum).toString());
		return (this.carMap.exists(carString));
	}
	
	public int addWashForCar (int carNum, int type, Date date) 
	{
		String carString = new String(new Integer(carNum).toString());
		if (!carExists(carNum))
			this.carMap.insert(carString,new CarWashData());
		CarWashData carWashData = this.carMap.getValue(carString);
		int washTimes = carWashData.getTotalWashes();
		
		carWashData.addWash(date,type);
		carWashData.addTotalWashes();
		if (type==1)
			carWashData.addType1Washes();
		else
			carWashData.addType2Washes();
		
		if (washTimes < BOUNDARY_OF_WASHES)
			if ( type ==1)
				return PRICE_FOR_FIRSTS_EXTERNAL_WASHES;
			else
				return PRICE_FOR_FIRSTS_COMBINED_WASHES;
		else
		   if (type==1)
			  return PRICE_FOR_LASTS_EXTERNAL_WASHES;
		   else
			  return PRICE_FOR_LASTS_COMBINED_WASHES;
	}
	
	public void printAllWashes(int carNum)
	{
		if (!carExists(carNum))
			IO.println("no washes for car " + carNum);
		else
		{
			String carString = new String(new Integer(carNum).toString());
			CarWashData carWashData = this.carMap.getValue(carString);
			Node<Wash> pos = carWashData.getCarWashList().getFirst();
			int i=1;
			while (pos != null)
			{
				IO.println("Date"+i+":"+pos.getInfo().getDate()
						   +" Type:"+pos.getInfo().getType());
				pos = pos.getNext();
				i++;
			}
		}
	}
	
	public void printTotalWashesByType()
	{
		IO.println("Total washes by type:");
		String[] cars = this.carMap.getAllKeys();
		for (int i=0; i<cars.length; i++)
			IO.println("Car number: "+ cars[i] + " had " +
					this.carMap.getValue(cars[i]).getType1Washes() +" external washes and " +
					this.carMap.getValue(cars[i]).getType2Washes() +" combined washes.");
	}
	
	public void printAllWashesBetweenDates(Date fromDate,Date toDate)
	{
		IO.println("All washes between "+fromDate+" and "+toDate+":");
		String[] cars = this.carMap.getAllKeys();
		for (int i=0; i<cars.length; i++)
		{
			boolean first = true;
			CarWashData carWashData = this.carMap.getValue(cars[i]);
			Node<Wash> pos = carWashData.getCarWashList().getFirst();
			while (pos != null)
			{
				Date date = pos.getInfo().getDate();
				if (!date.before(fromDate) && date.before(toDate))
				{
					if (first)
					{
						IO.println("car number "+cars[i]+":");
						first = false;
					}
					IO.println("Date:"+date+" Type:"+pos.getInfo().getType());
				}
				pos = pos.getNext();
			}
		}
	}
}
