/**
 *   :   
 * @author  , '  
 * @version 3/1/2007
 */
public class Date
{
	private int day;
	private int month;
	private int year;

	//constructors:
	/**
	* creates a new Date object
	* @param day the day in the month(1-31)
	* @param month the month in the year
	* @param year the year (in 4 digits)
	*/
	public Date(int day, int month, int year) 
	{
		this.day = day;
		this.month = month;
		this.year = year;
	}
	
    public Date(Date date)
	{
		this.day = date.day;
		this.month = date.month;
		this.year = date.year;
	}

	/** returns the year */
	public int getYear()
	{
		return this.year;
	}
	
	/** returns the month */
	public int getMonth()
	{
		return this.month;
	}
	
	/** returns the Day */
	public int getDay()
	{
		return this.day;
	}
	
	/** sets the year
	 * @param yearToSet the value to be set
	 */
	public void setYear(int yearToSet)
	{
		this.year = yearToSet;
	}
	
	/** set the month
	 * @param monthToSet the value to be set
	 */
	public void setMonth(int monthToSet)
	{
		this.month = monthToSet;
	}
	
	/** sets the day 
	 *  @param dayToSet the value to be set
	 */
	public void  setDay(int dayToSet)
	{
		this.day = dayToSet;
	}

	/**
	* checks if this date comes before a given date
	* @param date2 the given date
	* @retun true iff this date comes before date2
	*/

	public boolean before(Date date2) 
	{
		if (this.year < date2.year)
			return true;
		if (this.year == date2.year) 
		{
			if (this.month < date2.month)
				return true;
			if (this.month == date2.month && this.day < date2.day)
				return true;
		}
		return false;
	}

	/**
	* builds String that represents 
	* this date in the following format:
	* day/month/year (30/9/1917)
	*/
	public String toString() 
	{
		return this.day +"/" + this.month + "/" + this.year;
	}
}
